#Made by Kerb (adapted for L2JLisvus by roko91)

import sys
from net.sf.l2j import Config
from net.sf.l2j.gameserver.model.quest import State
from net.sf.l2j.gameserver.model.quest import QuestState
from net.sf.l2j.gameserver.model.quest.jython import QuestJython as JQuest

qn = "603_DaimontheWhiteEyedPart1" 

#Npcs
EYE = 8683
TABLE1,TABLE2,TABLE3,TABLE4,TABLE5 = range(8548,8553)
#Items
EVIL_SPIRIT,BROKEN_CRYSTAL,U_SUMMON = range (7190,7193)
#Mobs
BUFFALO = 1299
BANDERSNATCH = 1297
GRENDEL = 1304
#Chance
DROP_CHANCE = 100

class Quest (JQuest) :
 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   cond = st.getInt("cond")
   htmltext = event
   if event == "8683-02.htm" :
      if st.getPlayer().getLevel() < 73 : 
         htmltext = "8683-01a.htm"
         st.exitQuest(1)
      else :
         st.set("cond","1")
         st.setState(STARTED)
         st.playSound("ItemSound.quest_accept")
   elif event == "8548-02.htm" :
      st.set("cond","2")
      st.playSound("ItemSound.quest_middle")
      st.giveItems(BROKEN_CRYSTAL,1)
   elif event == "8549-02.htm" :
      st.set("cond","3")
      st.playSound("ItemSound.quest_middle")
      st.giveItems(BROKEN_CRYSTAL,1)
   elif event == "8550-02.htm" :
      st.set("cond","4")
      st.playSound("ItemSound.quest_middle")
      st.giveItems(BROKEN_CRYSTAL,1)
   elif event == "8551-02.htm" :
      st.set("cond","5")
      st.playSound("ItemSound.quest_middle")
      st.giveItems(BROKEN_CRYSTAL,1)
   elif event == "8552-02.htm" :
      st.set("cond","6")
      st.playSound("ItemSound.quest_middle")
      st.giveItems(BROKEN_CRYSTAL,1)
   elif event == "8683-04.htm" :
      if st.getQuestItemsCount(BROKEN_CRYSTAL) < 5 :
          htmltext = "8683-08.htm"
      else :
          st.set("cond","7")
          st.takeItems(BROKEN_CRYSTAL,-1)
          st.playSound("ItemSound.quest_middle")
   elif event == "8683-07.htm" :
      if st.getQuestItemsCount(EVIL_SPIRIT) < 200 :
          htmltext = "8683-09.htm"
      else :
          st.takeItems(EVIL_SPIRIT,-1)
          st.giveItems(U_SUMMON,1)
          st.playSound("ItemSound.quest_finish")
          st.exitQuest(1)
   return htmltext


 def onTalk (self,npc,st):
   htmltext = "<html><body>You are either not on a quest that involves this NPC, or you don't meet this NPC's minimum quest requirements.</body></html>"
   if st :
     npcId = npc.getNpcId()
     id = st.getState()
     cond = st.getInt("cond")
     if cond == 0 :
       if npcId == EYE :
         htmltext = "8683-01.htm"
     elif cond == 1 :
       if npcId == EYE :
         htmltext = "8683-02a.htm"
       elif npcId == TABLE1 :
         htmltext = "8548-01.htm"
     elif cond == 2 :
       if npcId == EYE :
         htmltext = "8683-02a.htm"
       elif npcId == TABLE2 :
         htmltext = "8549-01.htm"
       else:
         htmltext = "table-no.htm"
     elif cond == 3 :
       if npcId == EYE :
         htmltext = "8683-02a.htm"
       elif npcId == TABLE3 :
         htmltext = "8550-01.htm"
       else:
         htmltext = "table-no.htm"
     elif cond == 4 :
       if npcId == EYE :
         htmltext = "8683-02a.htm"
       elif npcId == TABLE4 :
         htmltext = "8551-01.htm"
       else:
         htmltext = "table-no.htm"
     elif cond == 5 :
       if npcId == EYE :
         htmltext = "8683-02a.htm"
       elif npcId == TABLE5 :
         htmltext = "8552-01.htm"
       else:
         htmltext = "table-no.htm"
     elif cond == 6 :
       if npcId == EYE :
         htmltext = "8683-03.htm"
       else:
         htmltext = "table-no.htm"
     elif cond == 7 :
       if npcId == EYE :
         htmltext = "8683-05.htm"
     elif cond == 8 :
       if npcId == EYE :
           htmltext = "8683-06.htm"
   return htmltext

 def onKill(self,npc,player,isPet):
     partyMember = self.getRandomPartyMember(player,"7")
     if not partyMember: return
     st = partyMember.getQuestState(qn)
     if st :
         count = st.getQuestItemsCount(EVIL_SPIRIT)
         if st.getInt("cond") == 7 and count < 200 :
            chance = DROP_CHANCE * Config.RATE_DROP_QUEST
            numItems, chance = divmod(chance,100)
            if st.getRandom(100) < chance : 
               numItems += 1
            if numItems :
               if count + numItems >= 200 :
                  numItems = 200 - count
                  st.playSound("ItemSound.quest_middle")
                  st.set("cond","8")
               else:
                  st.playSound("ItemSound.quest_itemget")   
               st.giveItems(EVIL_SPIRIT,int(numItems))
     return

QUEST = Quest(603,qn,"Daimon the White-Eyed - Part 1")
CREATED     = State('Start',QUEST)
STARTED     = State('Started',QUEST)

QUEST.setInitialState(CREATED)

QUEST.addStartNpc(EYE)

QUEST.addTalkId(EYE)
QUEST.addTalkId(TABLE1)
QUEST.addTalkId(TABLE2)
QUEST.addTalkId(TABLE3)
QUEST.addTalkId(TABLE4)
QUEST.addTalkId(TABLE5)

QUEST.addKillId(BUFFALO)
QUEST.addKillId(BANDERSNATCH)
QUEST.addKillId(GRENDEL)

STARTED.addQuestDrop(EYE,EVIL_SPIRIT,1)
STARTED.addQuestDrop(EYE,BROKEN_CRYSTAL,1)